var Routington = require('./routington')

Routington.parse = function (string) {
  var options = Parse(string)
  if (!options) throw new Error('Invalid parsed string: ' + string)
  return options
}

function Parse(string) {
  var options = {
    name: '',
    string: {},
    regex: ''
  }

  // Is a simple string
  if (isValidSlug(string)) {
    options.string[string] = true
    return options
  }

  // Pipe-separated strings
  if (isPipeSeparatedString(string)) {
    string.split('|').forEach(function (x) {
      options.string[x] = true
    })
    return options
  }

  // Find a parameter name for the string
  string = string.replace(/^\:\w+\b/, function (_) {
    options.name = _.slice(1)
    return ''
  })

  // Return if the string is now empty
  if (!string) return options

  // Assume the capture is a regex if there are
  // non-word characters in the capture.
  if (/^\(.+\)$/.test(string) && (string = string.slice(1, -1))) {
    if (isPipeSeparatedString(string))
      string.split('|').filter(function (x) {
        options.string[x] = true
      })
    else
      options.regex = string

    return options
  }
}

function isValidSlug(x) {
  return x === ''
    || /^[\w\.-]+$/.test(x)
}

function isPipeSeparatedString(x) {
  return /^[\w\.\-][\w\.\-\|]+[\w\.\-]$/.test(x)
}
